Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParserXerces.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParserXerces.h	(revision 508)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParserXerces.h	(revision 508)
@@ -0,0 +1,148 @@
+#ifndef _X3D_PARSER_XERCES__H
+#define _X3D_PARSER_XERCES__H
+
+// ---------------------------------------------------------------------------
+//  Includes
+// ---------------------------------------------------------------------------
+#include <xercesc/sax/HandlerBase.hpp>
+#include "Mesh.h"
+
+XERCES_CPP_NAMESPACE_USE
+XERCES_CPP_NAMESPACE_BEGIN
+class AttributeList;
+XERCES_CPP_NAMESPACE_END
+
+class VspBspTree;
+class ViewCellsManager;
+
+class ViewCellsParseHandlers: public HandlerBase
+{
+public:
+  // -----------------------------------------------------------------------
+  //  Constructors and Destructor
+  // -----------------------------------------------------------------------
+  ViewCellsParseHandlers(VspBspTree *tree, 
+						 ViewCellsManager *viewCellsManager,
+						 ObjectContainer *objects);
+  ~ViewCellsParseHandlers();
+  
+  
+  // -----------------------------------------------------------------------
+  //  Getter methods
+  // -----------------------------------------------------------------------
+  unsigned int GetElementCount()
+  {
+    return mElementCount;
+  }
+  
+  unsigned int GetAttrCount()
+  {
+    return mAttrCount;
+  }
+  
+  unsigned int GetCharacterCount()
+  {
+    return mCharacterCount;
+  }
+  
+  unsigned int GetSpaceCount()
+  {
+    return mSpaceCount;
+  }
+
+
+  // -----------------------------------------------------------------------
+  //  Handlers for the SAX DocumentHandler interface
+  // -----------------------------------------------------------------------
+  void endElement(const XMLCh* const name);
+  void startElement(const XMLCh* const name, AttributeList& attributes);
+  void characters(const XMLCh* const chars, const unsigned int length);
+  void ignorableWhitespace(const XMLCh* const chars, const unsigned int length);
+  void resetDocument();
+
+  VspBspTree *mVspBspTree;
+  BspNode *mCurrentNode;
+  ViewCellContainer mViewCells;
+  ViewCellsManager *mViewCellsManager;
+  ObjectContainer *mObjects;
+
+  // Handlers for X3D
+  void StartLeaf(AttributeList& attributes);
+  void StartInterior(AttributeList& attributes);
+  void EndInterior();
+ 
+  void StartViewCell(AttributeList&  attributes);
+  void EndViewCells();
+
+  // -----------------------------------------------------------------------
+  //  Handlers for the SAX ErrorHandler interface
+  // -----------------------------------------------------------------------
+  void warning(const SAXParseException& exc);
+  void error(const SAXParseException& exc);
+  void fatalError(const SAXParseException& exc);
+  
+  
+private:
+  // -----------------------------------------------------------------------
+  //  Private data members
+  //
+  //  fAttrCount
+  //  fCharacterCount
+  //  fElementCount
+  //  fSpaceCount
+  //      These are just counters that are run upwards based on the input
+  //      from the document handlers.
+  // -----------------------------------------------------------------------
+  unsigned int    mAttrCount;
+  unsigned int    mCharacterCount;
+  unsigned int    mElementCount;
+  unsigned int    mSpaceCount;
+};
+
+// ---------------------------------------------------------------------------
+//  This is a simple class that lets us do easy (though not terribly efficient)
+//  trancoding of XMLCh data to local code page for display.
+// ---------------------------------------------------------------------------
+class StrX
+{
+public :
+  // -----------------------------------------------------------------------
+  //  Constructors and Destructor
+  // -----------------------------------------------------------------------
+  StrX(const XMLCh* const toTranscode)
+  {
+	  // Call the private transcoding method
+	  mLocalForm = XMLString::transcode(toTranscode);
+  }
+  
+  ~StrX()
+  {
+	  XMLString::release(&mLocalForm);
+  }
+  
+  // -----------------------------------------------------------------------
+  //  Getter methods
+  // -----------------------------------------------------------------------
+  const char* LocalForm() const
+  {
+    return mLocalForm;
+  }
+  
+private :
+  // -----------------------------------------------------------------------
+  //  Private data members
+  //
+  //  fLocalForm
+  //      This is the local code page form of the string.
+  // -----------------------------------------------------------------------
+  char*   mLocalForm;
+};
+
+inline XERCES_STD_QUALIFIER ostream&
+operator<<(XERCES_STD_QUALIFIER ostream& target, const StrX& toDump)
+{
+  target << toDump.LocalForm();
+  return target;
+}
+
+#endif
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h	(revision 496)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h	(revision 508)
@@ -96,5 +96,6 @@
 	  @returns true if samples were written successfully
   */
-  bool WriteSamples(const VssRayContainer &samples) const;
+  bool ExportSamples(const VssRayContainer &samples) const;
+
   /// scene graph loaded from file
   SceneGraph *mSceneGraph;
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp	(revision 485)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RayInfo.cpp	(revision 508)
@@ -139,12 +139,15 @@
 	// non-intersecting, otherwise polygon-plane intersections of bsp tree
 	// approaches are not eliminating any rays intersecting the polygon!
-
-	//if (t > GetMaxT())
+#if 1
 	if (t >= GetMaxT() - 1e-20)
 		return splitPlane.Side(ExtrapOrigin());
-	//if (t < GetMinT())
 	if (t <= GetMinT() + 1e-20)
 		return splitPlane.Side(ExtrapTermination());
-
+#else
+	if (t > GetMaxT())
+		return splitPlane.Side(ExtrapOrigin());
+	else if (t < GetMinT())
+		return splitPlane.Side(ExtrapTermination());
+#endif
 	return 0;
 }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Polygon3.cpp	(revision 508)
@@ -477,5 +477,5 @@
 	int i = 1;
 	int j = 0;
-	int k = mVertices.size() - 1;
+	int k = (int)mVertices.size() - 1;
 	int count = 0;
 
@@ -490,2 +490,57 @@
 	}
 }
+
+
+void Polygon3::Triangulate(VertexIndexContainer &indices)
+{
+	int i = 1;
+	int j = 0;
+	int k = (int)mVertices.size() - 1;
+
+	int count = 0;
+
+	while (i < k)
+	{
+		indices.push_back(k);
+		indices.push_back(j);
+		indices.push_back(i);
+
+		if ((count ++) % 2)
+			j = i ++;
+		else
+			j = k --;
+	}
+}
+
+
+void Polygon3::AddToMesh(Mesh &mesh)
+{
+	const int n = (int)mesh.mVertices.size();
+
+    //-- add the vertices
+    VertexContainer::const_iterator vit, vit_end = mVertices.end();
+	for (vit = mVertices.begin(); vit != vit_end; ++ vit)
+	{
+		mesh.mVertices.push_back(*vit);
+	}
+
+	// one quad => no triangulation necessary
+	if ((int)mVertices.size() == 4)
+	{
+		mesh.AddFace(new Face(n, n + 1, n + 2, n + 3));
+	}
+	else
+	{
+		VertexIndexContainer indices;
+		Triangulate(indices);
+
+		// add indices of triangle strip
+		for (int i = 0; i < (int)indices.size(); i += 3)
+		{
+			Face *face = new Face(n + indices[i], 
+								  n + indices[i + 1], 
+								  n + indices[i + 2]);
+			mesh.AddFace(face);
+		}
+	}
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp	(revision 508)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsParser.cpp	(revision 508)
@@ -0,0 +1,472 @@
+// ---------------------------------------------------------------------------
+//  Includes for all the program files to see
+// ---------------------------------------------------------------------------
+#include <string.h>
+#include <stdlib.h>
+#include <iostream>
+using namespace std;
+#include <xercesc/util/PlatformUtils.hpp>
+
+// ---------------------------------------------------------------------------
+//  Includes
+// ---------------------------------------------------------------------------
+#include <xercesc/framework/StdInInputSource.hpp>
+#include <xercesc/parsers/SAXParser.hpp>
+#include <xercesc/util/OutOfMemoryException.hpp>
+
+// ---------------------------------------------------------------------------
+//  Includes
+// ---------------------------------------------------------------------------
+#include <xercesc/sax/AttributeList.hpp>
+#include <xercesc/sax/SAXParseException.hpp>
+#include <xercesc/sax/SAXException.hpp>
+
+#include "ViewCellsParser.h"
+
+#include "ViewCellsParserXerces.h"
+#include "Mesh.h"
+#include "VspBspTree.h"
+#include "ViewCellBsp.h"
+#include "ViewCellsManager.h"
+
+// ---------------------------------------------------------------------------
+//  Local data
+//
+//  doNamespaces
+//      Indicates whether namespace processing should be enabled or not.
+//      The default is no, but -n overrides that.
+//
+//  doSchema
+//      Indicates whether schema processing should be enabled or not.
+//      The default is no, but -s overrides that.
+//
+//  schemaFullChecking
+//      Indicates whether full schema constraint checking should be enabled or not.
+//      The default is no, but -s overrides that.
+//
+//  valScheme
+//      Indicates what validation scheme to use. It defaults to 'auto', but
+//      can be set via the -v= command.
+// ---------------------------------------------------------------------------
+static bool     doNamespaces       = false;
+static bool     doSchema           = false;
+static bool     schemaFullChecking = false;
+static SAXParser::ValSchemes    valScheme       = SAXParser::Val_Auto;
+
+
+
+
+
+// ---------------------------------------------------------------------------
+//  StdInParseHandlers: Constructors and Destructor
+// ---------------------------------------------------------------------------
+ViewCellsParseHandlers::ViewCellsParseHandlers(VspBspTree *tree,
+											   ViewCellsManager *viewCells,
+											   ObjectContainer *objects):
+  mElementCount(0)
+  , mAttrCount(0)
+  , mCharacterCount(0)
+  , mSpaceCount(0)
+{
+	mVspBspTree = tree;
+	mCurrentNode = tree->GetRoot();
+	mViewCellsManager = viewCells;
+	mObjects = objects;
+}
+
+ViewCellsParseHandlers::~ViewCellsParseHandlers()
+{
+}
+
+
+// ---------------------------------------------------------------------------
+//  StdInParseHandlers: Implementation of the SAX DocumentHandler interface
+// ---------------------------------------------------------------------------
+
+
+void ViewCellsParseHandlers::endElement(const XMLCh* const name)
+{
+  StrX lname(name);
+  string element(lname.LocalForm());
+  if (element == "Interior")
+	  EndInterior();
+  if (element == "ViewCells")
+	  EndViewCells();
+}
+
+
+void ViewCellsParseHandlers::EndInterior()
+{
+	// go one up in the tree
+	if (mCurrentNode->GetParent())
+	{	cout << "]";
+		mCurrentNode = mCurrentNode->GetParent();
+	}
+}
+
+
+inline bool vlt(ViewCell *v1, ViewCell *v2)
+{
+	return v1->mId < v2->mId;
+}
+
+
+void ViewCellsParseHandlers::EndViewCells()
+{
+	// sort view cells for easily finding id
+	stable_sort(mViewCells.begin(), mViewCells.end(), vlt);
+}
+
+
+void ViewCellsParseHandlers::startElement(const XMLCh* const name,
+										  AttributeList& attributes)
+{
+	StrX lname(name);
+	string element(lname.LocalForm());
+	
+	if (element == "ViewCell")
+	{
+		cout << "v";
+		StartViewCell(attributes);
+	}
+
+	if (element == "Interior") 
+	{
+		cout << "[";
+		StartInterior(attributes);
+	}
+
+	if (element == "Leaf") 
+	{
+		StartLeaf(attributes);
+	}
+
+	++ mElementCount;
+	mAttrCount += attributes.getLength();
+}
+
+
+inline bool ilt(Intersectable *obj1, Intersectable *obj2)
+{
+	return obj1->mId < obj2->mId;
+}
+
+
+void ViewCellsParseHandlers::StartViewCell(AttributeList&  attributes)
+{
+	int len = attributes.getLength();
+	vector<int> objIndices;
+  
+	ViewCell *viewCell = mViewCellsManager->GenerateViewCell();
+	mViewCells.push_back(viewCell);
+
+	for (int i = 0; i < len; ++ i) 
+	{
+		string attrName(StrX(attributes.getName(i)).LocalForm());
+		
+		if (attrName == "pvs") 
+		{
+			StrX attrValue(attributes.getValue(i));
+			
+			// handle coordIndex
+			objIndices.clear();
+			const char *ptr = attrValue.LocalForm();
+			char *endptr;
+			
+			while (1)
+			{
+				int index = strtol(ptr, &endptr, 10);
+
+				if (ptr == endptr)
+					break;
+
+				objIndices.push_back(index);
+
+				ptr = endptr;
+			}
+
+			//TODO: find objects and add them to pvs
+			// TODO: get view cell with specified id
+			MeshInstance dummyInst(NULL);
+
+			vector<int>::const_iterator it, it_end = objIndices.end();
+			for (it = objIndices.begin(); it != it_end; ++ it)
+			{
+				const int objId = *it;	
+				dummyInst.SetId(objId);
+
+				ObjectContainer::iterator oit =
+					lower_bound(mObjects->begin(), mObjects->end(), &dummyInst, ilt);
+			
+				Intersectable *obj = *oit;
+				
+				if (obj->GetId() == objId)
+				{
+					viewCell->GetPvs().AddSample(obj);
+				}
+				else
+				{
+					Debug << "error: object does not exist" << endl;
+				}
+			}
+		}
+		else if (attrName == "id") 
+		{
+			StrX attrValue(attributes.getValue(i));
+			
+			const char *ptr = attrValue.LocalForm();
+			char *endptr = NULL;
+			const int id = strtol(ptr, &endptr, 10);
+
+			viewCell->SetId(id);
+		}
+	}
+}
+
+
+void ViewCellsParseHandlers::StartLeaf(AttributeList& attributes)
+{
+	BspLeaf * leaf = 
+		new BspLeaf(dynamic_cast<BspInterior *>(mCurrentNode), NULL);
+
+	if (mCurrentNode) // replace front or (if not NULL) back child
+	{
+		dynamic_cast<BspInterior *>(mCurrentNode)->ReplaceChildLink(NULL, leaf);
+	}
+	else
+	{
+		mVspBspTree->mRoot = leaf;
+	}
+
+	//-- find associated view cell
+	int viewCellId;
+	
+	int len = attributes.getLength();
+	  
+	for (int i = 0; i < len; ++ i) 
+	{
+		string attrName(StrX(attributes.getName(i)).LocalForm());
+		StrX attrValue(attributes.getValue(i));
+
+		const char *ptr = attrValue.LocalForm();
+		char *endptr = NULL;
+
+		if (attrName == "viewCellId") 
+		{
+			viewCellId = strtol(ptr, &endptr, 10);
+		}
+	}
+
+	if (viewCellId >= 0) // valid view cell
+	{
+		// TODO: get view cell with specified id
+		ViewCell dummyVc;
+		dummyVc.SetId(viewCellId);
+
+		ViewCellContainer::iterator vit =
+			lower_bound(mViewCells.begin(), mViewCells.end(), &dummyVc, vlt);
+			
+		BspViewCell *viewCell = dynamic_cast<BspViewCell *>(*vit);
+		if (viewCell->GetId() == viewCellId)
+		{
+			leaf->SetViewCell(viewCell);
+		}
+		else
+		{
+			Debug << "error: view cell does not exist" << endl;
+		}
+	}
+	else
+	{
+		leaf->SetViewCell(mVspBspTree->GetOrCreateOutOfBoundsCell());
+		leaf->SetTreeValid(false);
+		mVspBspTree->PropagateUpValidity(leaf);
+	}
+}
+
+
+void ViewCellsParseHandlers::StartInterior(AttributeList& attributes)
+{
+	Plane3 plane;
+	int len = attributes.getLength();
+
+	for (int i = 0; i < len; ++ i) 
+	{
+		string attrName(StrX(attributes.getName(i)).LocalForm());
+		StrX attrValue(attributes.getValue(i));
+		const char *ptr = attrValue.LocalForm();
+
+		if (attrName == "plane") 
+		{
+			sscanf(ptr, "%f %f %f %f",
+				   &plane.mNormal.x, &plane.mNormal.y, &plane.mNormal.z, &plane.mD);
+		}
+	}
+
+	BspInterior* interior = new BspInterior(plane);
+	
+	if (mCurrentNode) // replace NULL child of parent with current node
+	{
+		BspInterior *current = dynamic_cast<BspInterior *>(mCurrentNode);
+
+		current->ReplaceChildLink(NULL, interior);
+		interior->SetParent(current);
+	}
+	else
+	{
+		mVspBspTree->mRoot = interior;
+	}
+
+	mCurrentNode = interior;
+}
+
+
+void ViewCellsParseHandlers::characters(const XMLCh* const chars,
+										const unsigned int length)
+{
+	mCharacterCount += length;
+}
+
+
+void ViewCellsParseHandlers::ignorableWhitespace(const XMLCh* const chars,
+												 const unsigned int length)
+{
+	mSpaceCount += length;
+}
+
+
+void ViewCellsParseHandlers::resetDocument()
+{
+	mAttrCount = 0;
+	mCharacterCount = 0;
+	mElementCount = 0;
+	mSpaceCount = 0;
+}
+
+
+// ---------------------------------------------------------------------------
+//  StdInParseHandlers: Overrides of the SAX ErrorHandler interface
+// ---------------------------------------------------------------------------
+void
+ViewCellsParseHandlers::error(const SAXParseException& e)
+{
+  XERCES_STD_QUALIFIER cerr << "\nError at (file " << StrX(e.getSystemId())
+			    << ", line " << e.getLineNumber()
+			    << ", char " << e.getColumnNumber()
+			    << "): " << StrX(e.getMessage()) << XERCES_STD_QUALIFIER endl;
+}
+
+void
+ViewCellsParseHandlers::fatalError(const SAXParseException& e)
+{
+  XERCES_STD_QUALIFIER cerr << "\nFatal Error at (file " << StrX(e.getSystemId())
+			    << ", line " << e.getLineNumber()
+			    << ", char " << e.getColumnNumber()
+			    << "): " << StrX(e.getMessage()) << XERCES_STD_QUALIFIER endl;
+}
+
+void
+ViewCellsParseHandlers::warning(const SAXParseException& e)
+{
+  XERCES_STD_QUALIFIER cerr << "\nWarning at (file " << StrX(e.getSystemId())
+			    << ", line " << e.getLineNumber()
+			    << ", char " << e.getColumnNumber()
+			    << "): " << StrX(e.getMessage()) << XERCES_STD_QUALIFIER endl;
+}
+
+
+bool ViewCellsParser::ParseFile(const string filename, 
+								VspBspTree *tree,
+								ViewCellsManager *viewCells,
+								ObjectContainer *objects)
+{
+  // Initialize the XML4C system
+  try {
+    XMLPlatformUtils::Initialize();
+  }
+  
+  catch (const XMLException& toCatch)
+    {
+      XERCES_STD_QUALIFIER cerr << "Error during initialization! Message:\n"
+				<< StrX(toCatch.getMessage()) << XERCES_STD_QUALIFIER endl;
+      return false;
+    }
+  
+  
+  //
+  //  Create a SAX parser object. Then, according to what we were told on
+  //  the command line, set the options.
+  //
+  SAXParser* parser = new SAXParser;
+  parser->setValidationScheme(valScheme);
+  parser->setDoNamespaces(doNamespaces);
+  parser->setDoSchema(doSchema);
+  parser->setValidationSchemaFullChecking(schemaFullChecking);
+  
+
+  //
+  //  Create our SAX handler object and install it on the parser, as the
+  //  document and error handler. We are responsible for cleaning them
+  //  up, but since its just stack based here, there's nothing special
+  //  to do.
+  //
+  ViewCellsParseHandlers handler(tree, viewCells, objects);
+  parser->setDocumentHandler(&handler);
+  parser->setErrorHandler(&handler);
+  
+  unsigned long duration;
+  int errorCount = 0;
+  // create a faux scope so that 'src' destructor is called before
+  // XMLPlatformUtils::Terminate
+  {
+    //
+    //  Kick off the parse and catch any exceptions. Create a standard
+    //  input input source and tell the parser to parse from that.
+    //
+    //    StdInInputSource src;
+    try
+      {
+	const unsigned long startMillis = XMLPlatformUtils::getCurrentMillis();
+	parser->parse(filename.c_str());
+	const unsigned long endMillis = XMLPlatformUtils::getCurrentMillis();
+	duration = endMillis - startMillis;
+	errorCount = parser->getErrorCount();
+      }
+    catch (const OutOfMemoryException&)
+      {
+	XERCES_STD_QUALIFIER cerr << "OutOfMemoryException" << XERCES_STD_QUALIFIER endl;
+	errorCount = 2;
+	return false;
+      }
+    catch (const XMLException& e)
+      {
+	XERCES_STD_QUALIFIER cerr << "\nError during parsing: \n"
+				  << StrX(e.getMessage())
+				  << "\n" << XERCES_STD_QUALIFIER endl;
+	errorCount = 1;
+	return false;
+      }
+
+    
+    // Print out the stats that we collected and time taken
+    if (!errorCount) {
+      XERCES_STD_QUALIFIER cout << filename << ": " << duration << " ms ("
+				<< handler.GetElementCount() << " elems, "
+				<< handler.GetAttrCount() << " attrs, "
+				<< handler.GetSpaceCount() << " spaces, "
+				<< handler.GetCharacterCount() << " chars)" << XERCES_STD_QUALIFIER endl;
+    }
+  }
+  
+  //
+  //  Delete the parser itself.  Must be done prior to calling Terminate, below.
+  //
+  delete parser;
+  
+  XMLPlatformUtils::Terminate();
+  
+  if (errorCount > 0)
+    return false;
+  else
+    return true;
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 503)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellsManager.cpp	(revision 508)
@@ -11,5 +11,5 @@
 #include "Exporter.h"
 #include "VspBspTree.h"
-
+#include "ViewCellsParser.h"
 
 ViewCellsManager::ViewCellsManager():
@@ -66,5 +66,5 @@
 
 
-bool ViewCellsManager::LoadViewCells(const string filename)
+bool ViewCellsManager::LoadViewCells(const string filename, ObjectContainer *objects)
 {
 	X3dParser parser;
@@ -317,6 +317,7 @@
 {
 	mViewCells.clear();
-
+	
 	CollectViewCells();
+	
 	mViewCellsStats.Reset();
 	EvaluateViewCellsStats();
@@ -328,7 +329,4 @@
 void ViewCellsManager::ComputeSampleContributions(VssRay &ray)
 {
-
-
-
   ViewCellContainer viewcells;
 
@@ -445,5 +443,12 @@
 
 
-void ViewCellsManager::ExportViewCells(Exporter *exporter) const
+void ViewCellsManager::CreateUniqueViewCellIds()
+{
+	for (int i = 0; i < (int)mViewCells.size(); ++ i)
+		mViewCells[i]->SetId(i);
+}
+
+
+void ViewCellsManager::ExportViewCellsForViz(Exporter *exporter) const
 {
 	ViewCellContainer::const_iterator it, it_end = mViewCells.end();
@@ -457,5 +462,4 @@
 
 
-
 void ViewCellsManager::CreateViewCellsMeshes()
 {
@@ -468,4 +472,27 @@
 	}
 }
+
+
+bool ViewCellsManager::ExportViewCells(const string filename) 
+{ 
+	return false;
+}
+
+
+void ViewCellsManager::ExportViewCell(ViewCell *viewCell, ofstream &stream)
+{
+	stream << "<ViewCell id=\"" << viewCell->GetId() << "\" ";
+	stream << "pvs=\"";
+
+	ObjectPvsMap::iterator it, it_end = viewCell->GetPvs().mEntries.end();
+	if(0) // test with empty pvs
+	for (it = viewCell->GetPvs().mEntries.begin(); it != it_end; ++ it)
+	{
+		stream << (*it).first->GetId() << " ";
+	}
+
+	stream << "\" />" << endl;
+}
+
 
 /**********************************************************************/
@@ -617,5 +644,5 @@
 			//exporter->SetWireframe();
 			exporter->SetFilled();
-			ExportViewCells(exporter);
+			ExportViewCellsForViz(exporter);
 
 			if (mExportGeometry)
@@ -723,5 +750,5 @@
 		if (exporter)
 		{
-			ExportViewCells(exporter);
+			ExportViewCellsForViz(exporter);
 			delete exporter;
 		}
@@ -1605,5 +1632,5 @@
 	//else exporter->SetFilled();
 
-	ExportViewCells(exporter);
+	ExportViewCellsForViz(exporter);
 
 	if (mExportGeometry)
@@ -1789,6 +1816,6 @@
 	GetRaySets(rays, mConstructionSamples, constructionRays, &savedRays);
 
-	Debug << "construction rays: " << (int)savedRays.size() << endl;
-	Debug << "saved rays: " << (int)constructionRays.size() << endl;
+	Debug << "construction rays: " << (int)constructionRays.size() << endl;
+	Debug << "saved rays: " << (int)savedRays.size() << endl;
 
 	mVspBspTree->Construct(constructionRays, &mSceneBox);
@@ -1818,5 +1845,5 @@
 			//exporter->SetWireframe();
 			exporter->SetFilled();
-			ExportViewCells(exporter);
+			ExportViewCellsForViz(exporter);
 
 			if (0 && mExportRays)
@@ -1909,5 +1936,5 @@
 			//exporter->SetWireframe();
 			exporter->SetFilled();
-			ExportViewCells(exporter);
+			ExportViewCellsForViz(exporter);
 
 			if (mExportGeometry)
@@ -1960,5 +1987,11 @@
 	}
 
+	// real meshes are only contructed only at this stage
 	CreateViewCellsMeshes();
+	// write view cells to disc
+	if (mExportViewCells)
+	{
+		ExportViewCells("viewcells.xml");
+	}
 
 	return 0;
@@ -2025,5 +2058,5 @@
 			}
 
-			ExportViewCells(exporter);
+			ExportViewCellsForViz(exporter);
 			delete exporter;
 		}
@@ -2310,7 +2343,7 @@
 ViewCell *VspBspViewCellsManager::GetViewCell(const Vector3 &point)
 {
-  if (!mVspBspTree)
-	return NULL;
-  return mVspBspTree->GetViewCell(point);
+	if (!mVspBspTree)
+		return NULL;
+	return mVspBspTree->GetViewCell(point);
 }
 
@@ -2327,2 +2360,58 @@
 	mMeshContainer.push_back(mesh);
 }
+
+
+bool VspBspViewCellsManager::LoadViewCells(const string filename, ObjectContainer *objects)
+{
+	ViewCellsParser parser;
+	
+	DEL_PTR(mVspBspTree);
+	mVspBspTree = new VspBspTree();
+	
+	bool success = parser.ParseFile(filename, mVspBspTree, this, objects);
+	ResetViewCells();
+	
+	Debug << (int)mViewCells.size() << " view cells loaded" << endl;
+
+	return success;
+}
+
+
+inline bool ilt(Intersectable *obj1, Intersectable *obj2)
+{
+	return obj1->mId < obj2->mId;
+}
+
+
+bool VspBspViewCellsManager::ExportViewCells(const string filename)
+{
+	cout << "exporting view cells to xml ... "; 
+	std::ofstream stream;
+
+	// for output we need unique ids
+	CreateUniqueViewCellIds();
+
+	stream.open(filename.c_str());
+	stream << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"<<endl;
+	stream << "<Visibility_Solution>" << endl;
+	
+	//-- load the view cells itself, i.e., the ids and the pvs
+	stream << "<ViewCells>" << endl;
+	ViewCellContainer::const_iterator it, it_end = mViewCells.end();
+	for (it = mViewCells.begin(); it != it_end; ++ it)
+		ExportViewCell(*it, stream);
+    
+	stream << "</ViewCells>" << endl;
+	
+	//-- load the hierarchy
+	stream << "<BspTree>" << endl;
+	mVspBspTree->Export(stream);
+	stream << endl << "</BspTree>" << endl;
+	
+	stream << "</Visibility_Solution>" << endl;
+	stream.close();
+
+	cout << "finished" << endl;
+
+	return true;
+}
